/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Model20
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Model20 {
  @SerializedName("product_code")
  private String productCode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("coverages")
  private Coverages coverages = null;

  @SerializedName("prices")
  private Prices prices = null;

  @SerializedName("criteria")
  private ProductsCriteria criteria = null;

  @SerializedName("attachments")
  private Model19 attachments = null;

  @SerializedName("payment_periodicities")
  private PaymentPeriodicities paymentPeriodicities = null;

  public Model20 productCode(String productCode) {
    this.productCode = productCode;
    return this;
  }

   /**
   * Product code.
   * @return productCode
  **/
  @ApiModelProperty(example = "KV5-33", required = true, value = "Product code.")
  public String getProductCode() {
    return productCode;
  }

  public void setProductCode(String productCode) {
    this.productCode = productCode;
  }

  public Model20 name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Product code.
   * @return name
  **/
  @ApiModelProperty(example = "Advanced", value = "Product code.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Model20 description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Product marketing description
   * @return description
  **/
  @ApiModelProperty(example = "Advanced for more guarantees.", value = "Product marketing description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Model20 coverages(Coverages coverages) {
    this.coverages = coverages;
    return this;
  }

   /**
   * Get coverages
   * @return coverages
  **/
  @ApiModelProperty(required = true, value = "")
  public Coverages getCoverages() {
    return coverages;
  }

  public void setCoverages(Coverages coverages) {
    this.coverages = coverages;
  }

  public Model20 prices(Prices prices) {
    this.prices = prices;
    return this;
  }

   /**
   * Get prices
   * @return prices
  **/
  @ApiModelProperty(required = true, value = "")
  public Prices getPrices() {
    return prices;
  }

  public void setPrices(Prices prices) {
    this.prices = prices;
  }

  public Model20 criteria(ProductsCriteria criteria) {
    this.criteria = criteria;
    return this;
  }

   /**
   * Get criteria
   * @return criteria
  **/
  @ApiModelProperty(value = "")
  public ProductsCriteria getCriteria() {
    return criteria;
  }

  public void setCriteria(ProductsCriteria criteria) {
    this.criteria = criteria;
  }

  public Model20 attachments(Model19 attachments) {
    this.attachments = attachments;
    return this;
  }

   /**
   * Get attachments
   * @return attachments
  **/
  @ApiModelProperty(value = "")
  public Model19 getAttachments() {
    return attachments;
  }

  public void setAttachments(Model19 attachments) {
    this.attachments = attachments;
  }

  public Model20 paymentPeriodicities(PaymentPeriodicities paymentPeriodicities) {
    this.paymentPeriodicities = paymentPeriodicities;
    return this;
  }

   /**
   * Get paymentPeriodicities
   * @return paymentPeriodicities
  **/
  @ApiModelProperty(value = "")
  public PaymentPeriodicities getPaymentPeriodicities() {
    return paymentPeriodicities;
  }

  public void setPaymentPeriodicities(PaymentPeriodicities paymentPeriodicities) {
    this.paymentPeriodicities = paymentPeriodicities;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Model20 model20 = (Model20) o;
    return Objects.equals(this.productCode, model20.productCode) &&
        Objects.equals(this.name, model20.name) &&
        Objects.equals(this.description, model20.description) &&
        Objects.equals(this.coverages, model20.coverages) &&
        Objects.equals(this.prices, model20.prices) &&
        Objects.equals(this.criteria, model20.criteria) &&
        Objects.equals(this.attachments, model20.attachments) &&
        Objects.equals(this.paymentPeriodicities, model20.paymentPeriodicities);
  }

  @Override
  public int hashCode() {
    return Objects.hash(productCode, name, description, coverages, prices, criteria, attachments, paymentPeriodicities);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Model20 {\n");
    
    sb.append("    productCode: ").append(toIndentedString(productCode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    coverages: ").append(toIndentedString(coverages)).append("\n");
    sb.append("    prices: ").append(toIndentedString(prices)).append("\n");
    sb.append("    criteria: ").append(toIndentedString(criteria)).append("\n");
    sb.append("    attachments: ").append(toIndentedString(attachments)).append("\n");
    sb.append("    paymentPeriodicities: ").append(toIndentedString(paymentPeriodicities)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

